%
% Roughly based on parameters from Pags model for Sorghum plant.
%
% Copyright 2009-2013 Daniel Leitner & Marcel Bachmann. See license.txt for details.
%

clear all;
set(0,'RecursionLimit',10000);

%
% Type 0
%
p{1}.name = 'Type 0';
p{1}.r = 0.3;
p{1}.lb = 0.07; % ibasal zone in Pages' model? (=ln?)
p{1}.la = 1*p{1}.r; % (duration in days) * r = length of apical zone
p{1}.ln = 0.07;        
p{1}.nob = 9; % if k = 4 -> (4-lb-la)/ln = 8.52 
p{1}.a = 0.15;       
p{1}.theta = 0;      
p{1}.color = [0.5,0.5,0.5]; % grey    
p{1}.tropism = [1,3,5*pi/180]; % strong gravitroism, small deviation
p{1}.dx=0.5;
p{1}.successor = 2;       

%
% Type 1
%
p{2}.name = 'Type 1';
p{2}.r = 1.5;          
p{2}.lb = 0.3; % is there a basal zone in Pages' model? (=ln?)
p{2}.la = 8*p{2}.r;  % (duration in days) * r = length of apical zone
p{2}.ln = 0.15;         
p{2}.nob = [459,99]; % if k = 150 -> (150-lb-la)/ln = 459, ks~30 -> nobs=99
p{2}.a = 0.15/2;       
p{2}.theta = [pi-2.2,0]; % 0.4
p{2}.color = [1,1,0]; % yellow     
p{2}.tropism = [2,1,20*pi/180];  % exotropism
p{2}.dx=0.5;
p{2}.successor = [3,0.05; 4,0.6; 5, 0.35]; % type, chance; ...; 

%
% Type 2
%
p{3}.name = 'Type 2';
p{3}.r = 0.6;          
p{3}.lb = 0.5; % is there a basal zone in Pages' model? (=ln?)
p{3}.la = 4.8; % (duration in days) * r = length of apical zone
p{3}.ln = 0.5;          
p{3}.nob = [2+2,1]; % if k = 6 -> (6-lb-la)/ln = 1.4, ks~0.6 -> nobs=1   
p{3}.a = 0.05;      
p{3}.theta = [1.4,0.3];  
p{3}.color = [0,0,1]; % blue         
p{3}.tropism = [1,0,20*pi/180]; 
p{3}.dx=0.5;
p{3}.successor = [4,0.2; 5,0.8]; % type, chance; ...

%            
% Type 3
%
p{4}.name = 'Type 3';
p{4}.r  = 0.3;        
p{4}.la  = [1.8,0.3];
p{4}.a  = 0.03;       
p{4}.theta = [1.2,0.3];
p{4}.color = [0,1,0];  % green
p{4}.tropism = [1,0,20*pi/180]; %
p{4}.dx=0.5;

%
% Type 4
%
p{5}.name = 'Type 4';
p{5}.r  = 0.2;            
p{5}.la  = [0.6,0.1];
p{5}.a  = 0.02;          
p{5}.theta = 1.57;    
p{5}.color = [1,0,0]; % red
p{5}.tropism = [1,0,20*pi/180]; %
p{5}.dx=0.5;
 
p = completeParameters(p);

%
% Simulation
%
days = 50;
root = createRootSystem(); 
str = applyRules(root,days);

plotTubes(str);

% Movie 
% mtime = 10; % seconds
% simtime = 50; % days
% fview = @(t) view(t/mtime*360,0); % rotation
% makeMovie('Sorghum.avi',root,simtime,mtime,fview); 




